import { GraphQLResolveInfo, GraphQLScalarType, GraphQLScalarTypeConfig } from 'graphql';
export declare type Maybe<T> = T | null;
export declare type Exact<T extends {
    [key: string]: unknown;
}> = {
    [K in keyof T]: T[K];
};
export declare type MakeOptional<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]?: Maybe<T[SubKey]>;
};
export declare type MakeMaybe<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]: Maybe<T[SubKey]>;
};
export declare type RequireFields<T, K extends keyof T> = {
    [X in Exclude<keyof T, K>]?: T[X];
} & {
    [P in K]-?: NonNullable<T[P]>;
};
/** All built-in and custom scalars, mapped to their actual values */
export declare type Scalars = {
    ID: string;
    String: string;
    Boolean: boolean;
    Int: number;
    Float: number;
    AnyObject: any;
    Date: any;
    DateTime: any;
    JSON: any;
    JSONObject: any;
    Time: any;
    URI: any;
    URIInput: any;
};
export declare type IFieldError = {
    __typename?: 'FieldError';
    field: Scalars['String'];
    message: Scalars['String'];
};
export declare type IGeoLocation = {
    __typename?: 'GeoLocation';
    type?: Maybe<Scalars['String']>;
    coordinates?: Maybe<Array<Maybe<Scalars['Float']>>>;
};
/**  All Moleculer Topic names are extended from this. */
export declare enum IMoleculerServiceName {
    SmsService = "SmsService",
    dummy = "dummy"
}
export declare type IMutation = {
    __typename?: 'Mutation';
    dummy?: Maybe<Scalars['Int']>;
    sendSms: Scalars['Boolean'];
};
export declare type IMutationsendSmsArgs = {
    sms?: Maybe<ISendSmsInput>;
};
export declare type INode = {
    id: Scalars['ID'];
};
export declare type IQuery = {
    __typename?: 'Query';
    dummy?: Maybe<Scalars['Int']>;
};
export declare type ISendSmsInput = {
    to: Scalars['String'];
    body: Scalars['String'];
};
export declare enum ISmsServiceActions {
    send = "send"
}
export declare type ISort = {
    key: Scalars['String'];
    value: ISortEnum;
};
export declare enum ISortEnum {
    ASC = "ASC",
    DESC = "DESC"
}
export declare type ISubscription = {
    __typename?: 'Subscription';
    dummy?: Maybe<Scalars['Int']>;
};
export declare type ResolverTypeWrapper<T> = Promise<T> | T;
export declare type ResolverWithResolve<TResult, TParent, TContext, TArgs> = {
    resolve: ResolverFn<TResult, TParent, TContext, TArgs>;
};
export declare type LegacyStitchingResolver<TResult, TParent, TContext, TArgs> = {
    fragment: string;
    resolve: ResolverFn<TResult, TParent, TContext, TArgs>;
};
export declare type NewStitchingResolver<TResult, TParent, TContext, TArgs> = {
    selectionSet: string;
    resolve: ResolverFn<TResult, TParent, TContext, TArgs>;
};
export declare type StitchingResolver<TResult, TParent, TContext, TArgs> = LegacyStitchingResolver<TResult, TParent, TContext, TArgs> | NewStitchingResolver<TResult, TParent, TContext, TArgs>;
export declare type Resolver<TResult, TParent = {}, TContext = {}, TArgs = {}> = ResolverFn<TResult, TParent, TContext, TArgs> | ResolverWithResolve<TResult, TParent, TContext, TArgs> | StitchingResolver<TResult, TParent, TContext, TArgs>;
export declare type ResolverFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => Promise<TResult> | TResult;
export declare type SubscriptionSubscribeFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => AsyncIterator<TResult> | Promise<AsyncIterator<TResult>>;
export declare type SubscriptionResolveFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => TResult | Promise<TResult>;
export interface SubscriptionSubscriberObject<TResult, TKey extends string, TParent, TContext, TArgs> {
    subscribe: SubscriptionSubscribeFn<{
        [key in TKey]: TResult;
    }, TParent, TContext, TArgs>;
    resolve?: SubscriptionResolveFn<TResult, {
        [key in TKey]: TResult;
    }, TContext, TArgs>;
}
export interface SubscriptionResolverObject<TResult, TParent, TContext, TArgs> {
    subscribe: SubscriptionSubscribeFn<any, TParent, TContext, TArgs>;
    resolve: SubscriptionResolveFn<TResult, any, TContext, TArgs>;
}
export declare type SubscriptionObject<TResult, TKey extends string, TParent, TContext, TArgs> = SubscriptionSubscriberObject<TResult, TKey, TParent, TContext, TArgs> | SubscriptionResolverObject<TResult, TParent, TContext, TArgs>;
export declare type SubscriptionResolver<TResult, TKey extends string, TParent = {}, TContext = {}, TArgs = {}> = ((...args: any[]) => SubscriptionObject<TResult, TKey, TParent, TContext, TArgs>) | SubscriptionObject<TResult, TKey, TParent, TContext, TArgs>;
export declare type TypeResolveFn<TTypes, TParent = {}, TContext = {}> = (parent: TParent, context: TContext, info: GraphQLResolveInfo) => Maybe<TTypes> | Promise<Maybe<TTypes>>;
export declare type IsTypeOfResolverFn<T = {}, TContext = {}> = (obj: T, context: TContext, info: GraphQLResolveInfo) => boolean | Promise<boolean>;
export declare type NextResolverFn<T> = () => Promise<T>;
export declare type DirectiveResolverFn<TResult = {}, TParent = {}, TContext = {}, TArgs = {}> = (next: NextResolverFn<TResult>, parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => TResult | Promise<TResult>;
/** Mapping between all available schema types and the resolvers types */
export declare type IResolversTypes = {
    AnyObject: ResolverTypeWrapper<Scalars['AnyObject']>;
    Date: ResolverTypeWrapper<Scalars['Date']>;
    DateTime: ResolverTypeWrapper<Scalars['DateTime']>;
    FieldError: ResolverTypeWrapper<IFieldError>;
    String: ResolverTypeWrapper<Scalars['String']>;
    GeoLocation: ResolverTypeWrapper<IGeoLocation>;
    Float: ResolverTypeWrapper<Scalars['Float']>;
    JSON: ResolverTypeWrapper<Scalars['JSON']>;
    JSONObject: ResolverTypeWrapper<Scalars['JSONObject']>;
    MoleculerServiceName: IMoleculerServiceName;
    Mutation: ResolverTypeWrapper<{}>;
    Int: ResolverTypeWrapper<Scalars['Int']>;
    Boolean: ResolverTypeWrapper<Scalars['Boolean']>;
    Node: never;
    ID: ResolverTypeWrapper<Scalars['ID']>;
    Query: ResolverTypeWrapper<{}>;
    SendSmsInput: ISendSmsInput;
    SmsServiceActions: ISmsServiceActions;
    Sort: ISort;
    SortEnum: ISortEnum;
    Subscription: ResolverTypeWrapper<{}>;
    Time: ResolverTypeWrapper<Scalars['Time']>;
    URI: ResolverTypeWrapper<Scalars['URI']>;
    URIInput: ResolverTypeWrapper<Scalars['URIInput']>;
};
/** Mapping between all available schema types and the resolvers parents */
export declare type IResolversParentTypes = {
    AnyObject: Scalars['AnyObject'];
    Date: Scalars['Date'];
    DateTime: Scalars['DateTime'];
    FieldError: IFieldError;
    String: Scalars['String'];
    GeoLocation: IGeoLocation;
    Float: Scalars['Float'];
    JSON: Scalars['JSON'];
    JSONObject: Scalars['JSONObject'];
    Mutation: {};
    Int: Scalars['Int'];
    Boolean: Scalars['Boolean'];
    Node: never;
    ID: Scalars['ID'];
    Query: {};
    SendSmsInput: ISendSmsInput;
    Sort: ISort;
    Subscription: {};
    Time: Scalars['Time'];
    URI: Scalars['URI'];
    URIInput: Scalars['URIInput'];
};
export interface IAnyObjectScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['AnyObject'], any> {
    name: 'AnyObject';
}
export interface IDateScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Date'], any> {
    name: 'Date';
}
export interface IDateTimeScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['DateTime'], any> {
    name: 'DateTime';
}
export declare type IFieldErrorResolvers<ContextType = any, ParentType extends IResolversParentTypes['FieldError'] = IResolversParentTypes['FieldError']> = {
    field?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    message?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export declare type IGeoLocationResolvers<ContextType = any, ParentType extends IResolversParentTypes['GeoLocation'] = IResolversParentTypes['GeoLocation']> = {
    type?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    coordinates?: Resolver<Maybe<Array<Maybe<IResolversTypes['Float']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export interface IJSONScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['JSON'], any> {
    name: 'JSON';
}
export interface IJSONObjectScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['JSONObject'], any> {
    name: 'JSONObject';
}
export declare type IMutationResolvers<ContextType = any, ParentType extends IResolversParentTypes['Mutation'] = IResolversParentTypes['Mutation']> = {
    dummy?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    sendSms?: Resolver<IResolversTypes['Boolean'], ParentType, ContextType, RequireFields<IMutationsendSmsArgs, never>>;
};
export declare type INodeResolvers<ContextType = any, ParentType extends IResolversParentTypes['Node'] = IResolversParentTypes['Node']> = {
    __resolveType: TypeResolveFn<null, ParentType, ContextType>;
    id?: Resolver<IResolversTypes['ID'], ParentType, ContextType>;
};
export declare type IQueryResolvers<ContextType = any, ParentType extends IResolversParentTypes['Query'] = IResolversParentTypes['Query']> = {
    dummy?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
};
export declare type ISubscriptionResolvers<ContextType = any, ParentType extends IResolversParentTypes['Subscription'] = IResolversParentTypes['Subscription']> = {
    dummy?: SubscriptionResolver<Maybe<IResolversTypes['Int']>, "dummy", ParentType, ContextType>;
};
export interface ITimeScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Time'], any> {
    name: 'Time';
}
export interface IURIScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['URI'], any> {
    name: 'URI';
}
export interface IURIInputScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['URIInput'], any> {
    name: 'URIInput';
}
export declare type IResolvers<ContextType = any> = {
    AnyObject?: GraphQLScalarType;
    Date?: GraphQLScalarType;
    DateTime?: GraphQLScalarType;
    FieldError?: IFieldErrorResolvers<ContextType>;
    GeoLocation?: IGeoLocationResolvers<ContextType>;
    JSON?: GraphQLScalarType;
    JSONObject?: GraphQLScalarType;
    Mutation?: IMutationResolvers<ContextType>;
    Node?: INodeResolvers<ContextType>;
    Query?: IQueryResolvers<ContextType>;
    Subscription?: ISubscriptionResolvers<ContextType>;
    Time?: GraphQLScalarType;
    URI?: GraphQLScalarType;
    URIInput?: GraphQLScalarType;
};
